\RequirePackage[l2tabu, orthodox]{nag}
\documentclass[12pt]{amsart}
\usepackage{fullpage,url,amssymb,enumerate,colonequals,pdfsync,float,mathtools,appendix,float,amsmath}
% \usepackage[all]{xy} % for commutative diagrams
%\usepackage{mathrsfs} % for \mathscr (script letters)

\usepackage{listings}
\usepackage{rotating}
\newcommand*{\isoarrow}[1]{\arrow[#1,"\rotatebox{90}{\(\sim\)}"]}


\usepackage{tikz-cd,graphicx}

\newcommand{\defi}[1]{\textsf{#1}} % for defined terms



\makeatletter
\g@addto@macro\bfseries{\boldmath} % This makes math in section titles bold.
\makeatother

\usepackage{microtype}

%%% \renewcommand{\baselinestretch}{3}   % for triple spacing

\usepackage[
%	draft,
%	colorlinks,
backref,
pdfauthor={Solomon}, % add other authors
%	pdftitle={Paper title goes here},
]{hyperref}
\usepackage[alphabetic,backrefs,lite,nobysame]{amsrefs} % for bibliography

\usepackage{color}


\usepackage[framemethod=tikz]{mdframed}

\newcommand{\isaac}[1]{{\color{magenta} \textsf{$\spadesuit\spadesuit\spadesuit$ isaac: [#1]}}}

\newcommand{\blue}[1]{{\color{blue} #1}}
\newcommand{\magenta}[1]{{\color{magenta} #1}}
\newcommand{\green}[1]{{\color{ForestGreen} #1}}

\numberwithin{figure}{section}


\title{STATS 302: Homework 7}
\author{Elchanan Solomon}
\date{\today}

\begin{document}

	
	\maketitle
	\thispagestyle{empty}
	
\begin{enumerate}
	\item Let $f(n),g(n), h(n)$ be real-valued functions on the set of natural numbers. Prove the following properties of the convolution:
	\[f \ast g (n) = \sum_{m} f(n)g(n-m)\]
	\begin{itemize}
		\item $f \ast g = g \ast f$.
		\item $f \ast (g \ast h) = (f \ast g) \ast h$.
		\item $f \ast (g+h) = f \ast g + f \ast h$.
		\item $(\alpha f) \ast g = \alpha (f \ast g)$.
	\end{itemize}
	\item Given a $3 \times 3$ image and a $2 \times 2$ filter $F$,
	\[F = \begin{pmatrix}
		a & b\\ c & d
	\end{pmatrix}\]
	convolution without any padding and stride $(1,1)$ gives a $2 \times 2$ image as the result. From the perspective of linear algebra, $F$ gives rise to a linear transformation $T_{a,b,c,d}$ from $\mathbb{R}^9$ to $\mathbb{R}^4$. Write the matrix for this linear transformation in the standard basis.
\item One of the crucial features of convolutional layers is their translational equivariance. Let's see what this means in simple terms. Let $f(n)$ be a 1D signal, to be convolved with $g(n)$ to produce $f \ast g$. Suppose that we shift $f(n)$ to the right to produce $f_{k}(n) = f(n-k)$. What is the relationship between $f \ast g$ and $f_{k} \ast g$?
\item Another important feature of convolutional layers is \emph{reduction of complexity}. Let $M_{4 \times 9}$ be the space of all $4 \times 9$ matrices. Let $W$ be the subspace of all linear transformations of the form $T_{a,b,c,d}$, as the choice of $a,b,c,d$ are varied (see exercise $2$). Compare the dimension of $M_{4 \times 9}$ with the dimension of $W$.
%Implement a Neural Network with one hidden layer (30 neurons) for MNIST. Then implement with $L^1$ regularization. Find a regularization parameter that makes the result better than unregularized optimization. Useful code:
%	\begin{verbatim}
%		from keras.regularizers import l1, l2
%		model = keras.models.Sequential()
%		model.add(keras.layers.Flatten(input_shape=[28,28]))
%		model.add(keras.layers.Dense(30,activation = "relu",activity_regularizer = l1(0.0001)))
%		model.add(keras.layers.Dense(10,activation = "softmax"))
%		model.compile(loss="sparse_categorical_crossentropy",optimizer="sgd",metrics=["accuracy"])
%		#train model
%		history = model.fit(X_train,y_train,epochs=30, validation_data=(X_valid,y_valid))
%		#plot epoch accuracy
%		pd.DataFrame(history.history).plot(figsize=(8,5))
%		plt.grid(True)
%		plt.gca().set_ylim(0,1)
%		plt.show()
%		#evaluate on test set
%		model.evaluate(X_test,y_test)
%	\end{verbatim}

	

\end{enumerate}
	

\end{document}